"{ Package: 'stx:goodies/monticello/test' }"

MCTestCase subclass:#MCFileInTest
	instanceVariableNames:'stream expected diff'
	classVariableNames:''
	poolDictionaries:''
	category:'Monticello-Tests'
!


!MCFileInTest methodsFor:'asserting'!

assertNoChange
	| actual |
	actual _ MCSnapshotResource takeSnapshot.
	diff _ actual patchRelativeToBase: expected.
	self assert: diff isEmpty
! !

!MCFileInTest methodsFor:'running'!

setUp
        expected _ self mockSnapshot.
        Smalltalk isSmalltalkX ifTrue:[
            stream _ (ReadWriteStream on: String new) binary.
        ] ifFalse:[
            stream _ RWBinaryOrTextStream on: String new.
        ].
!

tearDown
	(diff isNil or: [diff isEmpty not])
		 ifTrue: [expected updatePackage: self mockPackage]
! !

!MCFileInTest methodsFor:'testing'!

alterInitialState
	self mockClassA touchCVar
!

assertFileOutFrom: writerClass canBeFiledInWith: aBlock
self halt.
        (writerClass on: stream) writeSnapshot: self mockSnapshot.
        self alterInitialState.
        self assertSuccessfulLoadWith: aBlock.
        self mockPackage unload.
        self assertSuccessfulLoadWith: aBlock.
!

assertInitializersCalled
	| cvar |
	cvar _ self mockClassA cVar.
	self assert: cvar = #initialized
!

assertSuccessfulLoadWith: aBlock
self halt.
        stream reset.
        aBlock value.
        self assertNoChange.
        self assertInitializersCalled.
!

testStWriter
        self
                assertFileOutFrom: MCStWriter
                canBeFiledInWith: [self halt. stream fileIn].
! !

!MCFileInTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/monticello/test/MCFileInTest.st,v 1.2 2009-10-26 17:31:15 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/monticello/test/MCFileInTest.st,v 1.2 2009-10-26 17:31:15 cg Exp $'
! !
